<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/admin_top.php');

$data = array
(
	'display'		=> 'User',
	           	
	'sort'			=> 'name',
	'order'			=> 'desc',
	
	'SearchGroups'	=> array
	(
		array
		(
			'Keywords'	=> '',
			'Created'	=> '',
			'Country'	=> '',
			'State'		=> '',
			'City'		=> '',
			'Zip'		=> '',
			'Email'		=> '',
			'Phone'		=> ''
		)
	)
);

$countries = Country::getAll();

switch (@$_POST['mode'])
{
	case 'change_status':
	
		$obj = Entity::getObject(@$_POST['Entity'], @$_POST['EntityID']);
		if ($obj->{db_get_entity_key($obj)} != -1)
		{
			$obj->{$_POST['Entity'] . 'Status'} = intval(@$_POST['EntityStatus']);
			$obj->saveToDB();
		}
		break;
		
	case 'delete':
	
		$obj = Entity::getObject(@$_POST['Entity'], @$_POST['EntityID']);
		$obj->delete();
}

foreach ($_POST as $key => $value)
{
	$value = ud_sanitize($value);
	
	switch ($key)
	{               
		case 'SearchGroups':
		
			if ($_POST['mode'] == 'add_search')
			{
				$data['SearchGroups'] = array_merge($value, $data['SearchGroups']);
			}
			else
			{
				$data['SearchGroups'] = $value;
			}
			break;
			
		default:
		
			if (isset($data[$key]))
			{
				$data[$key] = $value;
			}
	}
}

$icons = array
(
	'icon_name'	 => 'triangle_g_down.gif',
	'icon_status' => 'triangle_g_down.gif'
);

switch ($data['sort'])
{                   
	case 'status':
		$icons['icon_status'] = 'triangle_r_';
		break;
		
	default:
		$icons['icon_name'] = 'triangle_r_';
		$data['sort'] = 'name';
}

switch ($data['order'])
{
	case 'asc':
		$icons['icon_' . $data['sort']] .= 'up.gif';
		break;
	
	default:
		$icons['icon_' . $data['sort']] .= 'down.gif';  
		$data['order'] = 'desc';
}                  

$template->setVariable($icons);          
$template->setVariable('sort',  $data['sort']);
$template->setVariable('order', $data['order']);
$db = DBConnect::getInstance();

$results = array
(
	'User'			=> array(),
	'Group'			=> array(),
	'Organization'	=> array(),
	'Community'		=> array()
);

for ($i = 0; $i < count($data['SearchGroups']); $i++)
{
	$search = $data['SearchGroups'][$i];
	
	if (isset($search['deleted']))
	{
		unset($data['SearchGroups'][$i]);
		$i--;
	}
	else
	{
		$template->setVariable('SearchGroupID',		$i);
		$template->setVariable('SearchGroupNumber',	$i + 1);
        
		$countrySelected = null;
		foreach ($countries as $country)
		{
			$template->setVariable('Key',	$country->CountryCode);
			$template->setVariable('Value',	$country->CountryName);
			
			if ($country->CountryCode == $search['Country'])
			{
				$template->touchBlock('country_selected');
                $countrySelected = $country;
			}
			
			$template->parse('country');
		}
        
        if (!is_null($countrySelected))
        {
            $states = $countrySelected->getStates();
            
            foreach ($states as $state)
            {
                $template->setVariable('Key',   $state->StateCode);
                $template->setVariable('Value', $state->StateName);
                
                if ($state->StateCode == $search['State'])
                {
                    $template->touchBlock('state_selected');
                }
                
                $template->parse('state');
            }        
        }


		$template->setVariable($search);
		
		$individuals	= array();
		$groups			= array();
		$organizations	= array();
		$communities	= array();
		
		if (isset($search['submited']))
		{            
			foreach ($search as $field => $value)
			{
				if ($value != '')
				{
					$value = ud_sanitize_db($value);
					
					switch ($field)
					{
						case 'Keywords':    
                            $individuals[] = '(UserFirstname like \'%' . $value . '%\' or UserLastname like \'%' . $value . '%\')';
							$groups[] = 'GroupKeywords like \'%' . $value . '%\'';
							$organizations[] = 'OrganizationKeywords like \'%' . $value . '%\'';
							$communities[] = 'CommunityKeywords like \'%' . $value . '%\'';
							break;      
                        	
						case 'State':
						case 'Country':							
						case 'City':
						case 'Zip':
                        case 'Phone':
                        case 'Email':
                            
                        	$individuals[] = 'User' . $field . ' like \'%' . $value . '%\'';
                        	break;
                        	
                        case 'Location':
                        	$individuals[] = '(UserState like \'%' . $value . '%\' or UserCountry like \'%' . $value . 
                        		'%\' or UserCity like \'%' . $value . '%\' or UserZip like \'%' . $value . '%\')';
                        	break;
                        	
                        case 'Created':
                        	$individuals[] = 'DATE_FORMAT(UserRegistrationDate, \'%m/%d/%Y\') = \'' . $value . '\'';
                        	$groups[] = 'DATE_FORMAT(GroupCreated, \'%m/%d/%Y\') = \'' . $value . '\'';
                        	$organizations[] = 'DATE_FORMAT(OrganizationCreated, \'%m/%d/%Y\') = \'' . $value . '\'';
                        	$communities[] = 'DATE_FORMAT(CommunityCreated, \'%m/%d/%Y\') = \'' . $value . '\'';
					}
				}
			}
			
			if (count($individuals) > 0)
			{
				$result = $db->directQuery('select * from user where UserType = ' . USER_TYPE_MEMBER . ' and ' . 
					join(' and ', $individuals) . ' order by ' . get_sort_field('User', $data['sort']) . ' ' . $data['order']);
                $individuals = cmn_collect_objects('User', $result->Data);
			}

			if (count($groups) > 0)
			{
				$result = $db->directQuery('select * from `group` where ' . join(' and ', $groups) . 
					' order by ' . get_sort_field('Group', $data['sort']) . ' ' . $data['order']);
				$groups = cmn_collect_objects('Group', $result->Data);
			}

			if (count($organizations) > 0)
			{
				$result = $db->directQuery('select * from `organization` where ' . join(' and ', $organizations) . 
					' order by ' . get_sort_field('Organization', $data['sort']) . ' ' . $data['order']);
				$organizations = cmn_collect_objects('Organization', $result->Data);
			}

			if (count($communities) > 0)
			{
				$result = $db->directQuery('select * from `community` where ' . join(' and ', $communities) . 
					' order by ' . get_sort_field('Community', $data['sort']) . ' ' . $data['order']);
				$communities = cmn_collect_objects('Community', $result->Data);
			}			
			
			$template->touchBlock('button_update_search');
		}
		else
		{			
            $template->touchBlock('button_search');
		}
		
		if ($i)
		{
			$template->touchBlock('button_delete_search');
		}
		
		$template->setVariable('IndividualsCount',   count($individuals));
		$template->setVariable('GroupsCount',		 count($groups));
		$template->setVariable('OrganizationsCount', count($organizations));
		$template->setVariable('CommunitiesCount',   count($communities));
		
		$template->parse('search_group');
		
		$results['User']			= array_merge($results['User'], $individuals);
		$results['Group']			= array_merge($results['Group'], $groups);
		$results['Organization']	= array_merge($results['Organization'], $organizations);
		$results['Community']		= array_merge($results['Community'], $communities);
	}
}

if (!isset($search['submited']))
{
    $p = intval($_GET['p']) ? intval($_GET['p']) : 1;    

    $result = $db->directQuery('SELECT * FROM `user` WHERE UserType='.USER_TYPE_MEMBER.' LIMIT '.($p-1)*USERS_PER_PAGE.','.USERS_PER_PAGE );
    $individuals = cmn_collect_objects('User', $result->Data);
    $results['User']			= array_merge($results['User'], $individuals);

    $count = $db->directQuery('SELECT COUNT(*) AS cnt FROM `user` WHERE UserType='.USER_TYPE_MEMBER);
    $num_of_users = $count->Data[0]['cnt'];
    $num_of_pages = ceil($num_of_users / USERS_PER_PAGE);

    if ($num_of_pages > 1)
    {
        for ($i=1; $i<=$num_of_pages; $i++)
        {
            if ($p == $i)
                $page = $i;
            else
                $page = '<a href="customers.php?p='.$i.'">'.$i.'</a>';
            $template->setVariable('page', $page);
            $template->parse('page');
        }
    }
}

$template->setVariable('TotalIndividuals',	 count($results['User']));
$template->setVariable('TotalGroups',		 count($results['Group']));
$template->setVariable('TotalOrganizations', count($results['Organization']));
$template->setVariable('TotalCommunities',   count($results['Community'])); 

switch ($data['display'])
{
	case 'User':
	case 'Group':
	case 'Organization':
	case 'Community':
		
		$template->touchBlock($data['display'] . '_selected');
		$template->setGlobalVariable('Entity', $data['display']);
		$colored = false;
		
		foreach ($results[$data['display']] as $obj)
		{			
			$template->setVariable('Color', $colored ? '#c0e6ff' : '#ffffff');
			$template->setVariable('Url', '../' . cmn_get_manage_link($data['display'], $obj->{db_get_entity_key($obj)}));
			$template->setVariable('EntityName',    $obj->{db_get_entity_name($obj)});
			$template->setVariable('EntityID',      $obj->{db_get_entity_key($obj)});
			$template->touchBlock('EntityStatus_' . $obj->{$data['display'] . 'Status'});
			$template->parse('row');
			
			$colored = !$colored;
		}
}

function get_sort_field($entity, $sort)
{
	switch ($sort)
	{
		case 'status':
			return $entity . ucfirst($sort);
		
		case 'name':
			return $entity . ($entity == 'User' ? 'Email' : ucfirst($sort));
	}
}

require_once('includes/admin_bottom.php');
  
?>