<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'calendar';
require_once('includes/application_top.php');

if (Session::isCurrentSessionLoggedIn())
{
	$template->setGlobalVariable('SectionHeader', 'Calendar');

	$obj = $user;

	switch ($entity = ucfirst(isset($_GET['entity']) ? $_GET['entity'] : @$_GET['type']))
	{
		case 'User':
		case 'Organization':
		case 'Group':
		case 'Community':

			$obj = Entity::getObject($entity, @$_GET['id']);
	}


	if ($obj->{db_get_entity_key($obj)} != -1)
	{
		if ($obj->checkCalendarPrivacy($user->UserID))
		{
            if ((get_class($obj) == 'User') && ($obj->UserID == $user->UserID))
            {
                if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
                {
                    $template->touchBlock('invite_link');
                    $template->touchBlock('sync_link');
                }

                $template->touchBlock('edit_panel');
            }
            else
            {
                $template->touchBlock('back_link');
            }

			if (isset($_GET['delete']))
			{
				$event = new Event($_GET['delete']);
				if ($event->isAdmin($user->UserID))
				{
					$event->delete();
				}
			}

			$month = isset($_GET['month']) ? $_GET['month'] : date('m');
			$year  = isset($_GET['year']) ? $_GET['year'] : date('Y');
			$day   = isset($_GET['day']) ? $_GET['day'] : date('d');

			$time = mktime(0, 0, 0, $month, $day, $year);

			$next = mktime(0, 0, 0, date('m', $time), date('d', $time) + 1, date('Y', $time));
			$prev = mktime(0, 0, 0, date('m', $time), date('d', $time) - 1, date('Y', $time));

			$template->setVariable('NextMonth', date('m', $next));
			$template->setVariable('NextYear', date('Y', $next));
			$template->setVariable('NextDay', date('d', $next));

			$template->setVariable('PrevMonth', date('m', $prev));
			$template->setVariable('PrevYear', date('Y', $prev));
		    $template->setVariable('PrevDay', date('d', $prev));

			$template->setVariable('Entity', get_class($obj));
			$template->setVariable('EntityID', $obj->{db_get_entity_key($obj)});

			$arrEvents = $obj->getEvents();
			$arrEventsByDate = array();
			$arrEventsToday = array();

			$strToday = date('Y-m-d', $time);
			$arrEventsByDate[$strToday] = array();
			$template->setVariable('Today', $strToday);

			foreach ($arrEvents as $event)
			{
				$timestamp     = strtotime($event->EventStartDate);
				$end_timestamp = strtotime($event->EventEndDate);

				$event->EventStartTime = $timestamp;
				$event->EventEndTime = $end_timestamp;

				$timestamp = mktime(0, 0, 0, date("m", $timestamp),
					date("d", $timestamp), date("Y", $timestamp));

				$end_timestamp = mktime(0, 0, 0, date("m", $end_timestamp),
					date("d", $end_timestamp), date("Y", $end_timestamp));

				$days = 0;

				while ($timestamp <= $end_timestamp)
				{
					$event_date = date('Y-m-d', $timestamp);
					if (!isset($arrEventsByDate[$event_date]))
					{
						$arrEventsByDate[$event_date] = array();
					}
					$arrEventsByDate[$event_date][] = $event;

					$timestamp = mktime(0, 0, 0, date("m", $timestamp), date("d", $timestamp) + 1, date("Y", $timestamp));
					$days++;
				}

				if ($days == 1 && $event_date = $strToday)
				{
					$arrEventsToday[$event->EventID] = $event;
				}

			}

			foreach ($arrEventsByDate[$strToday] as $event)
			{
				if (!isset($arrEventsToday[$event->EventID]))
				{
					$template->setVariable('EventName',	 $event->EventName);
					$template->setVariable('EventID',	 $event->EventID);
					$template->setVariable('EventStartDate', $event->EventStartDate);
					$template->setVariable('EventEndDate', $event->EventEndDate);
                    if ($event->isAdmin($user->UserID))
                    {
                        $template->touchBlock('other_edit_delete');
                    }
					$template->parse('other_event');
				}
			}

			$time = strtotime("12:00am", $time);
			$hour = true;

			for ($i = 0; $i < 48; $i++)
			{
				if ($hour)
				{
					$template->setVariable('Hour',    date('h', $time));
					$template->setVariable('Minutes', date('i', $time));
					$template->setVariable('DayTime', date('A', $time));
					$template->parse('hour');
				}

				if ($intEventsCount = count($arrEventsToday))
				{
					foreach ($arrEventsToday as $event)
					{
						if ($time >= $event->EventStartTime)
						{
							if ($time - $event->EventStartTime < 1800)
							{
								$event->cellsCount = floor(($event->EventEndTime - $event->EventStartTime) / 60 / 30) + 1;

								$template->setVariable('CellsCount', $event->cellsCount);
								$template->setVariable('EventName',	 $event->EventName);
								$template->setVariable('EventID',	 $event->EventID);
                                if ($event->isAdmin($user->UserID))
                                {
                                    $template->touchBlock('edit_delete');
                                }
								/*
								$template->setVariable('EventStartDate', $event->EventStartDate);
								$template->setVariable('EventEndDate', $event->EventEndDate);
								*/
								$template->parse('event_start');
							}

							if ($event->cellsCount > 0)
							{
								$intEventsCount--;
							}

							$event->cellsCount--;
						}
					}

					for ($j = 0; $j < $intEventsCount; $j++)
					{
						$template->touchBlock('event_place');
						$template->parse('event_place');
					}
				}
				else
				{
					$template->touchBlock('event_place');
				}

				$template->touchBlock('row');  // may be empty
				$template->parse('row');

				$hour = !$hour;
				$time = strtotime("+30 minutes", $time);
			}
		}
	}
}
else
{
	cmn_unathorized_action();
}

require_once('includes/application_bottom.php');
?>