<?
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$form_id = isset($_GET['form_id']) ? $_GET['form_id'] : ( isset($_POST['FormID']) ? $_POST['FormID'] : -1 );
$form = new Form($form_id);

$object = $form->getOwner();
$entity = ucfirst(get_class($object));
$id = $object->{db_get_entity_key($object)};

if ( ($id == -1) || (!$object->hasMember($user->UserID)) )
{
	cmn_unauthorized_action();
}

if ($_POST['submitted'] == 'true')
{
	$members = $_POST['UserID'];

	$groups = $_POST['GroupID'];
	if (!empty($groups))
	{
		foreach ($groups as $group_id)
		{
			$group = new Group($group_id);
			$group_members = $group->getMembers();
			foreach ($group_members as $group_member)
			{
				if ($group_member->UserID != $user->UserID)
				{
					$members[] = $group_member->UserID;
				}
			}
		}
	}
	$organizations = $_POST['OrganizationID'];
	if (!empty($organizations))
	{
		foreach ($organizations as $organization_id)
		{
			$organization = new Organization($organization_id);
			$organization_members = $organization->getMembers();
			foreach ($organization_members as $organization_member)
			{
				if ($organization_member->UserID != $user->UserID)
				{
					$members[] = $organization_member->UserID;
				}
			}
		}
	}
	$communities = $_POST['CommunityID'];
	if (!empty($communities))
	{
		foreach ($communities as $community_id)
		{
			$community = new Community($community_id);
			$community_members = $community->getMembers();
			foreach ($community_members as $community_member)
			{
				if ($community_member->UserID != $user->UserID)
				{
					$members[] = $community_member->UserID;
				}
			}
		}
	}

    foreach ($members as $member_id)
    {
    	$form_submission = new FormSubmission();
    	$form_submission->UserID = $member_id;
    	$form_submission->FormID = $form_id;
    	$form_submission->FormSubmissionStatus = FORM_SUBMISSION_STATUS_PENDING;
    	$form_submission->saveToDB();

    	Message::sendUserMessage($user->UserID, $member_id, $_POST['RequestNote'], '<a target="_blank" href="form_submit.php?form_id=' . $form->FormID . '&submission_id=' . $form_submission->FormSubmissionID . '">' . FORM_REQUEST_NOTE_MESSAGE . '</a>');
	}
	print '<script type="text/javascript">self.close();</script>'; exit(0);
}

//$control = new MyConnections('CONNECTIONS', 'control.myconnections_select.html');
//$control->parseMembers($template, $entity, $id);

$control = new MyConnections('CONNECTIONS', 'control.myconnections_select.html');
$control->parse($template, $user->UserID, 0, false, $checked);

require_once('includes/application_bottom.php');