<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Listing
{
	public $Page		= 1;
	public $Limit		= RECORDS_PER_PAGE;
	public $DataSource	= null;

	public $onBeforeParseRow = '';

	private $place	= '';
	private $tpl	= null;

	public function __construct($strTemplate = '', $place = '')
	{
		if ($strTemplate != '')
		{
			$this->tpl = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);
			$this->tpl->loadTemplateFile($strTemplate);

			tpl_set_common_functions($this->tpl);
			$this->place = $place;
		}

		$this->Page = isset($_GET['page']) ? ud_sanitize($_GET['page']) : 1;
		$this->Limit = isset($_GET['limit']) ? ud_sanitize($_GET['limit']) : RECORDS_PER_PAGE;
	}

	public function parse($template, $query)
	{      
		$db		= DBConnect::getInstance();
		$args	= func_get_args();
		
		if (is_null($this->tpl))
		{
			$this->tpl = $template;
		}

		if (($argsCount = count($args)) > 1)
		{
			$eval = 'return $db->pageQuery(' . $this->Page . ', ' . $this->Limit . ', $args[1]';
			for ($i = 2; $i < $argsCount; $i++)
				$eval .= ', $args[' . $i . ']';
			$eval .= ');';
            
			$this->DataSource = eval($eval);

			if ($this->DataSource->Size > 0)
			{
				foreach ($this->DataSource->Data as $row)
				{
					foreach ($row as $key => $value)
					{
						$this->tpl->setVariable($key, $value);
					}

					if ($this->onBeforeParseRow != '')
					{
						$func = $this->onBeforeParseRow;
						$func($this->tpl, $row);
						$this->tpl->parse('row');
						$this->tpl->clearVariables();
					}
					else
					{
						$this->tpl->parse('row');
					}
				}

				$this->tpl->setGlobalVariable('PagesCount', $this->DataSource->PagesCount);
				$this->tpl->setGlobalVariable('PageNumber', $this->DataSource->PageNumber);

				for ($i = 1; $i <= $this->DataSource->PagesCount; $i++)
				{
					$template->setVariable('Page', $i);
					if ($i == $this->DataSource->PageNumber)
					{
						$template->parse('page_active');
					}
					else
					{
						$template->setGlobalVariable('PageURL', $this->getPageUrl($i));
						$template->parse('page_link');
					}
					$template->parse('page');
				}

				if ($this->DataSource->PagesCount > $this->Page)
				{
					$this->tpl->setGlobalVariable('urlNext', $this->getPageUrl($this->Page + 1));
					$this->tpl->setGlobalVariable('urlLast', $this->getPageUrl($this->DataSource->PagesCount));

					$this->tpl->touchBlock('next_top');
					$this->tpl->touchBlock('next_bottom');

					$this->tpl->touchBlock('last_top');
					$this->tpl->touchBlock('last_bottom');
				}

				if ($this->Page > 1)
				{
					$this->tpl->setGlobalVariable('urlFirst', $this->getPageUrl(1));
					$this->tpl->setGlobalVariable('urlPrev', $this->getPageUrl($this->Page - 1));
					$this->tpl->touchBlock('prev_top');
					$this->tpl->touchBlock('prev_bottom');

					$this->tpl->touchBlock('first_top');
					$this->tpl->touchBlock('first_bottom');
				}

				$this->tpl->touchBlock('limit_' . $this->Limit);

				if ($this->place != '')
				{
					$template->setVariable($this->place, $this->tpl->get());
				}
			}
		}

	}

	private function getPageUrl($page)
	{
		return cmn_self_link('page', $page);
	}
}
?>