<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class MyConnections
{
	private $place = '';
	private $tpl = null;

	public function __construct($place, $strTemplate = 'control.myconnections.html')
	{
			$this->tpl = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);
			$this->tpl->loadTemplateFile($strTemplate);

			tpl_set_common_functions($this->tpl);
			$this->place = $place;
	}

	public function parse($template, $userID, $limit = 10, $only_users = false, $arrChecked = array())
	{
		$user = new User($userID);

		if ($user->UserID != -1)
		{
			$connections = Connection::getUserConnections($user->UserID);

			$count = array('User' => 0);
			$data = array('User' => array());
			if (!$only_users)
			{
				$data['Group'] = array();
				$data['Organization'] = array();
				$data['Community'] = array();

				$count['Group'] = 0;
				$count['Organization'] = 0;
				$count['Community'] = 0;
			}

			foreach ($connections as $connection)
			{
				$target = $connection->getTarget($user);
				$class = get_class($target);
				if (isset($count[$class]))
				{
					if (!isset($data[$class][$target->{db_get_entity_key($target)}]))
					{
						if (!$limit || $count[$class] < $limit)
						{
							$this->tpl->setVariable('ID', $target->{db_get_entity_key($target)});
	                        $this->tpl->setVariable('Name', db_get_entity_display_name($target));
							$this->tpl->setVariable('Link', cmn_get_profile_link($class, $target->{db_get_entity_key($target)}));

							if ($connection->ConnectionType == CONNECTIONTYPE_OWNER || $connection->ConnectionType == CONNECTIONTYPE_ADMIN)
							{
								$this->tpl->setVariable('ManageLink', cmn_get_manage_link($class, $target->{db_get_entity_key($target)}));
								$this->tpl->parse($class . '_manage');
							}
							if (isset($arrChecked[$class][$target->{db_get_entity_key($target)}]))
							{
								$this->tpl->touchBlock($class . '_checked');
							}
							$this->tpl->parse($class);
						}
						$count[$class]++;
						$data[$class][$target->{db_get_entity_key($target)}] = $target;
					}
				}
			}

			$this->tpl->setVariable('UsersCount', $count['User']);
			$this->tpl->setVariable('GroupsCount', $count['Group']);
			$this->tpl->setVariable('OrganizationsCount', $count['Organization']);
			$this->tpl->setVariable('CommunitiesCount', $count['Community']);

			$template->setGlobalVariable($this->place, $this->tpl->get());
		}
	}
}
?>