<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Complaint extends Entity
{
	public $ComplaintID 		= -1;
	public $UserID				= -1;
	public $ToUserID			= -1;
	public $ComplaintSourceID 	= -1;       
	public $ComplaintSource 	= COMPLAINT_SOURCE_PRODUCT;
	public $ComplaintStatus 	= COMPLAINT_STATUS_NEW;
	public $ComplaintMessage 	= '';       
	public $ComplaintComments 	= '';
    
    function deleteSource()
    {
        $obj = null;
        switch ($this->ComplaintSource)
        {
            case COMPLAINT_SOURCE_PRODUCT:
                $obj = new Product($this->ComplaintSourceID);
                break;
                
            case COMPLAINT_SOURCE_GROUP:
                $obj = new Group($this->ComplaintSourceID);
                break;

            case COMPLAINT_SOURCE_ORGANIZATION:
                $obj = new Organization($this->ComplaintSourceID);
                break;

            case COMPLAINT_SOURCE_PHOTO:
                $obj = new Photo($this->ComplaintSourceID);
                break;

            case COMPLAINT_SOURCE_USER:
                $obj = new User($this->ComplaintSourceID);
                break;

            case COMPLAINT_SOURCE_VIDEO:
                $obj = new Video($this->ComplaintSourceID);
                break;
        }
        if (!is_null($obj))
        {
            $obj->delete();
            $this->delete();
        }
    }
}
?>