<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Order extends Entity
{
    public $OrderID                        = -1;
    public $UserID                        = -1;
    public $ProgramID                     = -1;
    public $OrderDate                    = CURRENT_TIME;
    public $OrderTotal                    = 0.00; 
    public $OrderStatus                    = ORDER_STATUS_PENDING;   // todo
    public $OrderBillingFirstName        = '';
    public $OrderBillingLastName        = '';
    public $OrderBillingAddress1        = '';
    public $OrderBillingAddress2        = '';
    public $OrderBillingCity            = '';
    public $OrderBillingState            = '';
    public $OrderBillingCountry            = '';
    public $OrderBillingZip                = '';
    public $OrderBillingPhone            = '';
    public $OrderPaymentType            = ORDER_PAYMENT_TYPE_CC;
    public $OrderPaymentCC                = '';
    public $OrderPaymentCVV                = '';
    public $OrderPaymentCCType            = '';
    public $OrderPaymentCCName            = '';
    public $OrderPaymentCCExpMonth        = '';
    public $OrderPaymentCCExpYear        = '';
    public $OrderPaymentCheck            = '';
    public $OrderPaymentCheckName        = '';
    public $OrderPaymentCheckRouting    = '';
    public $OrderPaymentCheckAccount    = '';
    public $OrderPaypalID               = '';
    
    public function getProgram()
    {
        return new Program($this->ProgramID);
    }
    public static function getAll()
    {
        return Entity::getAll('Order');
    }
    public function getStatusDescription()
    {
        return Order::getOrderStatusDescription($this->OrderStatus);
    }
    
    public static function getUserOrders($userID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select * from `order` where OrderStatus <> %d and UserID = %d', ORDER_STATUS_DELETED, $userID);
        $return = array();

        foreach ($result->Data as $row)
        {
            $order = new Order();
            $order->populateFromArray($row);
            $return[] = $order;
        }

        return $return;
    }

    public static function getProgramAmountGranted($programID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select sum(OrderTotal) as amount from `order` where ProgramID = %d and OrderStatus = %d', $programID, ORDER_STATUS_CHARGED);
        return $result->Data[0]['amount'];
    }

    public static function getOrderStatusDescription($orderStatus)
    {
        $return = '';

        switch ($orderStatus)
        {
            case ORDER_STATUS_PENDING:
                $return = 'Pending';
                break;

            case ORDER_STATUS_CHARGED:
                $return = 'Charged';
                break;

            case ORDER_STATUS_DECLINED:
                $return = 'Declined';

        }

        return $return;
    }


}
?>