<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class SentInvitation extends Entity
{
	public $SentInvitationID	= -1;
	public $UserID				= -1;
    public $GroupID             = -1;
    public $OrganizationID      = -1;
	public $SentInvitationEmail	= '';


    public static function getUserSentInvitationCount($userID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select count(*) as cnt from sentinvitation where UserID = %d', $userID);
        return intval($result->Data[0]['cnt']);
    }

    public static function getUserSentInvitationCountRank($userID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select count(*) as cnt, UserID from sentinvitation group by UserID order by cnt asc');
        for ($i = 0; $i < count($result->Data); $i++)
        {
            if ($userID == $result->Data[$i]['UserID'])
            {
                break;
            }
        }
        return $i + 1;
    }

    public function getSentInvitationCountRank()
    {
        return SentInvitation::getUserSentInvitationCountRank($this->UserID);
    }

    public function getSentInvitationCount()
    {
        return SentInvitation::getUserSentInvitationCount($this->UserID);
    }

	public static function getUserSentInvitations($userID)
	{
		$db = DBConnect::getInstance();
		$result = $db->query('select * from sentinvitation where UserID = %d', $userID);
		$return = array();

		foreach ($result->Data as $row)
		{
			$obj = new SentInvitation();
			$obj->populateFromArray($row);
			$return[] = $obj;
		}
		return $return;
	}

    public static function getGroupSentInvitations($groupID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select * from sentinvitation where GroupID = %d', $groupID);
        $return = array();

        foreach ($result->Data as $row)
        {
            $obj = new SentInvitation();
            $obj->populateFromArray($row);
            $return[] = $obj;
        }
        return $return;
    }

    public static function getOrganizationSentInvitations($organizationID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select * from sentinvitation where OrganizationID = %d', $organizationID);
        $return = array();

        foreach ($result->Data as $row)
        {
            $obj = new SentInvitation();
            $obj->populateFromArray($row);
            $return[] = $obj;
        }
        return $return;
    }
}
?>