<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


class Request
{
	public static function getString($name, $method = "get", $default = "")
	{
		$method = strtoupper($method);
		if (!in_array($method, array("GET", "POST", "REQUEST", "COOKIES")))
		{
			throw new RequestException("Unknown request method '" . $method . "'");
		}
		$source =& $GLOBALS["_" . $method];
		$result = isset($source[$name]) ? $source[$name] : $default;
		return strval($result);
	}

	public static function getInteger($name, $method = "get", $default = 0)
	{
		$result = self::getString($name, $method, $default);
		if (!is_numeric($result))
		{
			$result = $default;
		}
		return intval($result);
	}

	public static function getBoolean($name, $method = "get", $default = false)
	{
		$result = (boolean)self::getString($name, $method, $default);
		return $result;
	}

	public static function getFloat($name, $method = "get", $default = 0.0)
	{
		$result = self::getString($name, $method, $default);
		if (!is_numeric($result))
		{
			$result = $default;
		}
		return floatval($result);
	}

	public static function getArray($name, $method = "get")
	{
		$method = strtoupper($method);
		if (!in_array($method, array("GET", "POST", "REQUEST", "COOKIES")))
		{
			throw new RequestException("Unknown request method '" . $method . "'");
		}
		$source =& $GLOBALS["_" . $method];
		$result = isset($source[$name]) ? $source[$name] : array();
		return $result;
	}

	public static function getFile($name)
	{
		$result = null;
		if (isset($_FILES[$name]))
		{
			if (is_array($_FILES[$name]['name']))
			{
				$result = array();
				for ($i = 0; $i < count($_FILES[$name]['name']); $i++)
				{
					if ($_FILES[$name]['error'][$i] === UPLOAD_ERR_OK)
					{
						$result[] = new UploadedFile($_FILES[$name]['name'][$i],
								$_FILES[$name]['type'][$i],
								$_FILES[$name]['tmp_name'][$i],
								$_FILES[$name]['size'][$i],
								$_FILES[$name]['error'][$i]);
					}
				}
			}
			else
			{
				if ($_FILES[$name]['error'][$i] === UPLOAD_ERR_OK)
				{
					$result[] = new UploadedFile($_FILES[$name]['name'][$i],
							$_FILES[$name]['type'][$i],
							$_FILES[$name]['tmp_name'][$i],
							$_FILES[$name]['size'][$i],
							$_FILES[$name]['error'][$i]);
				}
			}
		}
		return $result;
	}
}