<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if ($user->isAuthorised())
{
	$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['group_id']) ? $_POST['group_id'] : -1 );
	$group = new Group($group_id);

	if (!$group->userIsAdmin($user->UserID))
	{
		cmn_unauthorized_action();
	}

	if ($_POST['submitted'] == 'true' && is_uploaded_file($_FILES['updatedInviteSpreadsheet']['tmp_name']))
	{
		$filename = $_FILES['updatedInviteSpreadsheet']['tmp_name'];

		$exc = new ExcelFileParser();
		$res = $exc->ParseFromFile($filename);

		$ws_num = 0;	
		$ws = $exc->worksheet['data'][$ws_num];

		$member_emails = array();
		$table_header = array();

		$ind = $ws['cell'][0][0]['data'];
		$table_header = $exc->sst['data'][$ind];

		for ($j = 1; $j <= $ws['max_row']; $j++)
		{
			$data = $ws['cell'][$j][0];
			$ind = $data['data'];
			$member_emails[$j] = $exc->sst['data'][$ind];
		}

		foreach ($member_emails as $key => $member_email)
		{
			$member = User::getByUserEmail($member_email);
			$member_id = $member->UserID;

			if ($member_id > 0)
			{
				$invitation = new Invitation();
				$invitation->GroupID = $group_id;
				$invitation->FromUserID = $user->UserID;
				$invitation->ToUserID = $member_id;
				$invitation->InvitationPermissions = CONNECTIONTYPE_MEMBER;
				$invitation->saveToDB();
			}
			else
			{
				$tpl = Message::getMessageTemplate('invitation_sent_message.html');
				$strMessage = $tpl->get();
			}
		}
	}

	$template->setVariable('path', CONNECTIONS_SPREADSHEET_TEMPLATE_NAME);
}
else
{
	cmn_unauthorized_action();
}

include('includes/application_bottom.php');