<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'account';
require('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$template->setGlobalVariable('SectionHeader', 'My Account');

$tab = isset($_GET['tab']) ? $_GET['tab'] : 0;
$template->setGlobalVariable('tab', $tab);

$action = isset($_GET['a']) ? $_GET['a'] : '';

// renew user account information
if (isset($_POST['submitted']))
{
	$data = $_POST;

	// My Account
	if ($tab == 0)
	{       
		$user->UserEmail = $_POST['UserEmail'];
		$user->UserFirstname = $_POST['FirstName'];
		$user->UserLastname = $_POST['LastName'];
		if (!empty($_POST['Password']))
		{
            if (in_array($user->UserEmail, $TESTUSERS))
            {
                $template->touchBlock('error_testuser_change_password');
            }
            else
            {
                $user->Password = md5($_POST['Password']);
            }
		}

		if ($_POST['deactivate'])
		{
            if (in_array($user->UserEmail, $TESTUSERS))
            {
                $template->touchBlock('error_testuser_delete');
            }
            else
            {            
			    $user->UserStatus = USER_STATUS_DEACTIVATED;
			    $template->touchBlock('deactivate_message');
            }
		}
		elseif ($user->UserStatus == USER_STATUS_DEACTIVATED)
		{
			$user->UserStatus = USER_STATUS_ACTIVE;
			$template->touchBlock('activate_message');
		}

		if ($_POST['btnDelete_x'] && $_POST['btnDelete_y'])
		{
            if (in_array($user->UserEmail, $TESTUSERS))
            {
                $template->touchBlock('error_testuser_delete');
            }
            else
            {
                $user->delete();
                $user->logout();
                cmn_unauthorized_action();            
            }
		}

		$user->saveToDB();
	}
	// My Profile
	elseif ($tab == 1)
	{
		$user->populateFromArray($data);
		if ($_POST['submitted'] == 'true')
		{
			$user->saveToDB();

			// update social group info
			SocialGroup::clearUserSocialGroups($user->UserID);
			for ($i = 1; $i < count($data['SocialGroupName']); $i++)
			{
				if (!empty($data['SocialGroupName'][$i]) && !empty($data['SocialGroupURL'][$i]))
				{
					$other_social_group = new SocialGroup();
					$other_social_group->GroupID = -1;
					$other_social_group->UserID = $user->UserID;
					$other_social_group->SocialGroupName = $data['SocialGroupName'][$i];
					$other_social_group->SocialGroupURL = $data['SocialGroupURL'][$i];
					$other_social_group->saveToDB();
				}

			}

			// update skill info
			Skill::clearUserSkills($user->UserID);
			for ($i = 1; $i < count($data['SkillName']); $i++)
			{
				if (!empty($data['SkillName'][$i]))
				{
					$skill = new Skill();
					$skill->UserID = $user->UserID;					
					$skill->SkillName = $data['SkillName'][$i];
					$skill->saveToDB();
				}
			}
		}

		// Education & Work
		$error = false;

		if (is_array($_POST['CompanyName']))
		{
			foreach ($_POST['CompanyName'] as $key => $company_name)
			{
				if ( empty($company_name) && ($key > 0) )
				{
					$error = true;
					$template->touchBlock('CompanyName_empty');
					break;
				}
			}
		}

		if (!$error)
		{
			// update job info			
			Company::clearUserCompanies($user->UserID);
			for ($i = 1; $i < count($data['CompanyName']); $i++)
			{
				$company = new Company();
				$company->UserID = $user->UserID;
				$company->CompanyName = $data['CompanyName'][$i];
				$company->CompanyUserTitle = $data['CompanyUserTitle'][$i];
				$company->CompanyStartDate = $data['CompanyStartDate'][$i];
				$company->CompanyEndDate = $data['CompanyEndDate'][$i];
				$company->CompanyDescription = $data['CompanyDescription'][$i];				
				$company->saveToDB();
			}
		}

        // School Info
		$error = false;

		if (is_array($_POST['SchoolName']))
		{
			foreach ($_POST['SchoolName'] as $key => $school_name)
			{
				if ( empty($school_name) && ($key > 0) )
				{
					$error = true;
					$template->touchBlock('SchoolName_empty');
					break;
				}
			}
		}

		if (!$error)
		{
			// update school info
			School::clearUserSchools($user->UserID);
			for ($i = 1; $i < count($data['SchoolName']); $i++)
			{
				$school = new School();
				$school->UserID = $user->UserID;
				$school->SchoolName = $data['SchoolName'][$i];

				$school->SchoolDescription = $data['SchoolDescription'][$i];
				$school->SchoolDegree = $data['SchoolDegree'][$i];

				$school->SchoolStartDate = $data['SchoolStartDate'][$i];
				$school->SchoolEndDate = $data['SchoolEndDate'][$i];
				
				$school->saveToDB();
			}
		}
	}

	// expand all previously expanded blocks
	if ($_POST['myaccount_content_expanded'])
		$template->touchBlock('expand_myaccount');
	if ($_POST['myprofile_content_expanded'])
		$template->touchBlock('expand_myprofile');		
	if ($_POST['my_other_contacts_content_expanded'])
		$template->touchBlock('expand_my_other_contacts');		
	if ($_POST['my_other_groups_content_expanded'])
		$template->touchBlock('expand_my_other_groups');				
	if ($_POST['favourites_content_expanded'])
		$template->touchBlock('expand_favourites');						
	if ($_POST['skills_content_expanded'])
		$template->touchBlock('expand_skills');								
	if ($_POST['educationandwork_content_expanded'])
		$template->touchBlock('expand_educationandwork');								
}

// rendering account data
if ($user->UserStatus == USER_STATUS_DEACTIVATED)
{
	$template->setVariable('deactivate_checked', 'checked');
}

$template->setVariable('UserEmail', $user->UserEmail);
$template->setVariable('UserFirstname', $user->UserFirstname);
$template->setVariable('UserLastname', $user->UserLastname);

if ($action == 'del')
{
	$id = isset($_GET['id']) ? $_GET['id'] : -1;
	if ($id != -1)
	{
		cmn_redirect('my_account.php');
	}
}
elseif ($action == 'remove_picture')
{
	$user->UserPicture = '';
	$user->saveToDB();
}


// rendering "my profile" info

$template->setVariable($user->getDataArray());

// show countries
foreach ($COUNTRIES as $code => $name)
{
	$template->setVariable('CountryCode', $code);
	$template->setVariable('Country', $name);
	if ($code == $user->UserCountry)
	{
		$template->setVariable('selected', 'selected');

	}
	$template->parse('country');
}

// show states
foreach ($STATES as $code => $name)
{
	$template->setVariable('StateCode', $code);
	$template->setVariable('State', $name);
	if ($code == $user->UserState)
	{
		$template->setVariable('selected', 'selected');
	}
	$template->parse('state');
}

$social_groups = $user->getUserSocialGroups();
foreach ($social_groups as $id => $social_group)
{
	$template->setVariable('SocialGroupName',	$social_group->SocialGroupName);
	$template->setVariable('SocialGroupURL',	$social_group->SocialGroupURL);
	$template->parse('social_group');
}

$skills = Skill::getUserSkills($user->UserID);
$data['SkillName'] = array();
foreach ($skills as $key => $object)
{
    $data['SkillName'][] = $object->SkillName;    
}

for ($i = 0; $i < count($data['SkillName']); $i++)
{
	if (!empty($data['SkillName'][$i]))
	{
		$template->setVariable('SkillName',	$data['SkillName'][$i]);		
		$template->parse('skill');
	}
}

$companies = Company::getUserCompanies($user->UserID);
foreach ($companies as $id => $company)
{
	$template->setVariable('CompanyName',	        $company->CompanyName);
	$template->setVariable('CompanyUserTitle',	    $company->CompanyUserTitle);
	$template->setVariable('CompanyDescription',    $company->CompanyDescription);
	$template->setVariable('CompanyStartDate',	    $company->CompanyStartDate);
	$template->setVariable('CompanyEndDate',	    $company->CompanyEndDate);
	if (empty($company->CompanyEndDate))
	{
		$template->touchBlock('work_current');
	}	
	$template->parse('job');
}

$schools = School::getUserSchools($user->UserID);
foreach ($schools as $id => $school)
{
	$template->setVariable('SchoolName',	$school->SchoolName);
	$template->setVariable('SchoolDegree',	$school->SchoolDegree);
	$template->setVariable('SchoolDescription',	$school->SchoolDescription);
	$template->setVariable('SchoolStartDate',	$school->SchoolStartDate);
	$template->setVariable('SchoolEndDate',	$school->SchoolEndDate);
	if (empty($school->SchoolEndDate))
	{
		$template->touchBlock('school_current');
	}	
	$template->parse('school');
}

if ($user->OnlyMyFlags & PRIVACY_FLAG_PERSONAL_INFO)
{
	$template->setVariable('pi_selected', 'checked');
}
if ($user->OnlyMyFlags & PRIVACY_FLAG_OTHER_CONTACTS)
{
	$template->setVariable('oc_selected', 'checked');
}
if ($user->OnlyMyFlags & PRIVACY_FLAG_OTHER_GROUPS)
{
	$template->setVariable('og_selected', 'checked');
}
if ($user->OnlyMyFlags & PRIVACY_FLAG_FAVOURITES)
{
	$template->setVariable('fv_selected', 'checked');
}
if ($user->OnlyMyFlags & PRIVACY_FLAG_SKILLS)
{
	$template->setVariable('sk_selected', 'checked');
}

$free = $user->getFreeSpace();
if ($user->UserStorage == 99999)
{
	$template->touchBlock('storage_unlimited');
}
else
{
	$template->setVariable('UserStorage', round($user->UserStorage / 1024 / 1024 / 1024, 2));
	$template->setVariable('StorageUsed', round(($user->UserStorage - $free) / 1024 / 1024 / 1024, 2));
	$pFree = $user->UserStorage ? ceil(($user->UserStorage - $free) * 100 / $user->UserStorage) : 0;
	$template->setVariable('PersentUsage', $pFree);
	$template->setVariable('PersentFree', 100 - $pFree);
}

// indisputable parse
$template->setVariable(array(
	'pi_privacy_flag' => PRIVACY_FLAG_PERSONAL_INFO,
	'oc_privacy_flag' => PRIVACY_FLAG_OTHER_CONTACTS,
	'og_privacy_flag' => PRIVACY_FLAG_OTHER_GROUPS,
	'fv_privacy_flag' => PRIVACY_FLAG_FAVOURITES,
	'sk_privacy_flag' => PRIVACY_FLAG_SKILLS,
));

$template->setVariable('UserPictureURL', PATH_USER_PICS . $user->UserID . '/' . '80px' . '/' . $user->UserPicture);

require('includes/application_bottom.php');