<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'my_connections';
include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}


$target		= $user;
$title		= 'My World';
$blnAdmin	= true;

function connections_tab_link($mode)
{
	return cmn_self_link('display', $mode, array('unblock', 'remove', 'page', 'limit'));
}

$template->setCallbackFunction('connections_tab_link', 'connections_tab_link');

switch (true)
{
	case isset($_GET['user_id']):
		$target = new User($_GET['user_id']);

		if (!($blnAdmin = $target->UserID == $user->UserID))
		{
			$title = $target->UserFirstname . ' ' . $target->UserLastname . '\'s Friends';
		}

        $template->setGlobalVariable('ConnectionsCSS', 'section');
		break;

	case isset($_GET['group_id']):

		$target = new Group($_GET['group_id']);

		$blnAdmin = $target->userIsAdmin($user->UserID);
		$title = $target->GroupName . '\'s Friends';
        $template->setVariable('GroupID', $target->GroupID);
        $template->parse('group_profile_link');
		$template->setGlobalVariable('ConnectionsCSS', 'main-content');
		$template->touchBlock('groups_orgs');

		$template->setVariable('Entity', 'group');
		$template->setVariable('EntityID',   $target->GroupID);
		$template->parse('back_link');

		break;
}

if ($target->{db_get_entity_key($target)} != -1)
{
    if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
    {
        $template->setVariable('ObjectEntity', strtolower(get_class($target)));
        $template->setVariable('ObjectID', $target->{db_get_entity_key($target)});
        $template->parse('connections_add_link');
    }

	$display = 'user';

	if (isset($_GET['display']))
	{
		$display = $_GET['display'];
	}

	$template->setGlobalVariable('SectionHeader',	$title);
	$template->setVariable('ChangeTabLink',	cmn_self_link('display', '', array('page', 'unblock', 'remove')));
	$template->setVariable('Display',		$display);
	$template->touchBlock($display . '_selected');

	$entities = array('user', 'group');
    $styles = array('user' => 'individuals', 'group' => 'groups');

	if (array_search($display, $entities) !== false)
	{
		switch ($display)
		{
			case 'user':
				$template->setVariable('tab', 0);
				break;

			case 'group':
				$template->setVariable('tab', 1);
				break;

		}

        if ($target == $user)
        {
            $template->setGlobalVariable('SectionStyle', $styles[$display]);
        }


        if ($blnAdmin)
        {
        	if (isset($_GET['remove']))
        	{
        		$obj = Entity::getObject($display, $_GET['remove']);
        		$target->removeConnection($obj);
                $obj->removeConnection($target);
        	}

			if (isset($_GET['unblock']))
			{
				$obj = Entity::getObject($display, $_GET['unblock']);
				$target->unblock($obj);
			}

			if (isset($_POST['connections']))
			{
				foreach (array('User', 'Group') as $entity)
				{
					if (is_array(@$_POST[$entity . 'ID']))
					{
						foreach ($_POST[$entity . 'ID'] as $id)
						{
							$obj = Entity::getObject($entity, $id);
							$target->block($obj);
						}
					}
				}
			}
		}

		$db = DBConnect::getInstance();

		$fieldTargetID = db_get_entity_key($target);
		$tableTarget   = db_get_table_name($target);

		$recordsCount  = array();

		foreach ($entities as $table)
		{
			$entity 		= ucfirst($table);

			$fieldID		= $entity . 'ID';
			$fieldName		= $entity == 'User' ?
                'concat_ws(\' \', e.UserFirstname, e.UserLastname)' :
                'e.' . db_get_entity_name($entity);

			$fieldPicture	= $entity . 'Picture';

			if ($tableTarget == $table)
			{
				$query = ' from `connection` c inner join %t t on (c.%f = t.%f or c.%f = t.%f) ' .
					'inner join %t e on (e.%f = c.%f or e.%f = c.%f) and e.%f <> t.%f where t.%f = %d and (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) group by e.%f';

				$params = array($tableTarget, 'To' . $fieldTargetID, $fieldTargetID, $fieldTargetID, $fieldTargetID, $table, $fieldID, 'To' . $fieldID, $fieldID, $fieldID, $fieldID, $fieldID, $fieldTargetID, $target->$fieldTargetID, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN,
					CONNECTIONTYPE_OWNER, CONNECTIONTYPE_BUDDY, $fieldID);
			}
			else
			{
				$query = ' from `connection` c inner join %t t on (c.%f = t.%f or c.%f = t.%f) ' .
					'inner join %t e on (e.%f = c.%f or e.%f = c.%f) where t.%f = %d and (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) group by e.%f';

				$params = array($tableTarget, 'To' . $fieldTargetID, $fieldTargetID, $fieldTargetID, $fieldTargetID, $table, $fieldID, 'To' . $fieldID, $fieldID, $fieldID, $fieldTargetID, $target->$fieldTargetID, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN,
					CONNECTIONTYPE_OWNER, CONNECTIONTYPE_BUDDY, $fieldID);
			}

			if ($display == $table)
			{

                
				$listing = new Listing('listing.connections.html', 'listing');
				$listing->onBeforeParseRow = parseConnection;
				
                $listing->parse($template, 'select NULL, %s as Entity, e.%f as ID, ' . $fieldName . ' as Title, e.%f as Picture' . $query,
					array_merge(array($entity, $fieldID, $fieldPicture), $params));
                
				$recordsCount[$table] = $listing->DataSource->Size;
			}
			else
			{
				$result = $db->query('select count(*) as cnt' . $query, $params);
				$recordsCount[$table] = $result->Size;
			}
		}

		switch ($display)
		{
			case 'user':

                if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
                {
				    $unions = $user->getGroups(true); // can be getUnions

				    foreach ($unions as $union)
				    {
					    $template->setVariable('UnionEntity', strtolower(get_class($union)));
					    $template->setVariable('UnionID', $union->{db_get_entity_key($union)});
					    $template->setVariable('UnionName', $union->{db_get_entity_name($union)});
					    $template->parse('union');
				    }
                    $template->parse('add_to_group');
				}
				$template->touchBlock('create_group_link');

			case 'group':
			
				$template->setVariable('TargetEntity', get_class($target));
				$template->setVariable('TargetID', $target->{db_get_entity_key($target)});

				$template->parse('buttons_' . $display . ($blnAdmin ? '_admin' : ''));
				$template->touchBlock('create_' . $display . '_link');
				break;

			default:

				if ($blnAdmin)
				{
                    $template->setVariable('TargetEntity', get_class($target));
                    $template->setVariable('TargetID', $target->{db_get_entity_key($target)});

					$template->parse('buttons_other_admin');
				}
		}

		$template->touchBlock($display . '_selected');

		foreach ($recordsCount as $table => $count)
		{
			$template->setVariable(ucfirst($table) . 'Count', intval($count));
		}
	}
}


function parseConnection($tpl, $row)
{
	global $target, $blnAdmin, $user;

	switch ($row['Entity'])
	{
		case 'User':

			if ($row['ID'] != $user->UserID)
			{
				$tpl->touchBlock('send_message');
			}
			break;

		case 'Group':

			$tpl->setVariable('MembersLink', cmn_get_profile_link('Group', $row['ID']));
			$tpl->setVariable('MembersCount',
				count
				(
					Connection::getConnections
					(
						array
						(
							'ConnectionType'	=> array(CONNECTIONTYPE_OWNER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER),
							'UserID'			=> '<> -1',
							'GroupID'			=> $row['ID']
						)
					)
				)
			);

			$tpl->parse('size');
	}

	$tpl->setVariable('EntityLink', cmn_get_profile_link($row['Entity'], $row['ID']));

	$db = DBConnect::getInstance();
	if ($row['Entity'] == 'User')
	{
		$result = $db->query('select * from `connection` where ' .
			'(ConnectionType = %d or ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) and UserID = %d limit 5',
			CONNECTIONTYPE_BUDDY, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID']);
	}
	else
	{
		$result = $db->query('select * from `connection` where (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) ' .
			'and (' . $row['Entity'] . 'ID' . ' = %d or To' . $row['Entity'] . 'ID' . ' = %d) and UserID = -1 limit 5',
			CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID'], $row['ID']);

	}

	$obj = Entity::getObject($row['Entity'], $row['ID']);

	foreach ($result->Data as $data)
	{
		$connection = new Connection();
		$connection->populateFromArray($data);

		$conTarget = $connection->getTarget($obj);

		$tpl->setVariable('ConnectionLink', cmn_get_profile_link(get_class($conTarget), $conTarget->{db_get_entity_key($conTarget)}));
		$tpl->setVariable('ConnectionTitle', (get_class($conTarget) == 'User' ?
                ($conTarget->UserFirstname . ' ' . $conTarget->UserLastname) :
                $conTarget->{db_get_entity_name($conTarget)}));
		$tpl->parse('connection');
	}

	if (!count($result->Data))
	{
		$tpl->touchBlock('connections_none');
	}
	//////

	if (empty($row['Picture']))
	{
		$tpl->touchBlock('no_picture');
		$tpl->hideBlock('picture');
	}

	if ($blnAdmin)
	{
		$obj = Entity::getObject($row['Entity'], $row['ID']);
        
		if ($target->isBlocked($obj))
		{
			$tpl->setVariable('UnblockEntity', $row['Entity']);
			$tpl->setVariable('UnblockLink', cmn_self_link('unblock', $row['ID'], array('remove')));
			$tpl->parse('unblock');
		}               
		elseif (strtolower($row['Entity']) != 'user') 
		{
            if (!$obj->isOwner($row['ID']))
            {
                $tpl->setVariable('RemoveLink', cmn_self_link('remove', $row['ID'], array('unblock')));
                $tpl->parse('remove_connection');
            }
		}
        
	}
	else
	{
		if ($row['Entity'] != 'User')
		{
			$tpl->hideBlock('checkbox');
		}
	}
}
include('includes/application_bottom.php');
?>