<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


require("includes/application_top.php");
define('PASSWORD_RECOVERY_INDEBUG', 1);

if (isset($_POST['submitted']))
{
	$error = false;
	if (isset($_POST['UserEmail']))
	{
        if (!$_POST['UserEmail'])
        {
			$error = true;
			$template->touchBlock('UserEmail_absent');
		}
		elseif (!chstr_is_mail($_POST['UserEmail']))
		{
			$error = true;
			$template->touchBlock('UserEmail_format');
		}
		if (!$error)
		{
			$user = User::getByUserEmail($_POST['UserEmail']);
			if ($user->UserID == -1)
			{
				$error = true;
				$template->touchBlock('UserEmail_notexists');
			}
		}
	}
    
	if (!$error)
	{
        if (in_array($user->UserEmail, $TESTUSERS))
        {
            $_SESSION['MESSAGES'] = array("testuser_recovery_error");
            cmn_redirect('index.php');         
        }
        else
        {
            $recoveredPassword = cmn_generate_password(PASSWORD_RECOVERY_LENGTH);
            $user->Password = md5($recoveredPassword);
            $user->saveToDB();
            $tpl = Message::getMessageTemplate("password_recovery_mail.html");
            $tpl->setVariable('RemindedUserName', $user->UserFirstname . ' ' . $user->UserLastname);
            $tpl->setVariable('Password', $recoveredPassword);
            $message = $tpl->get();

            $_SESSION['MESSAGES'] = array("password_recovery_messages");
            if (PASSWORD_RECOVERY_INDEBUG)
            {
                header('Refresh: 20;URL=index.php');
                print "<pre style=\"color:red\">Attention!\nPassword Recovery is working in a debug mode.\nIn order to change the mode set PASSWORD_RECOVERY_INDEBUG constant to 0!\nYou will be redirected to index in 20 seconds...\n\n";
                print $message . "</pre>";
            }
            else
            {
                mail($_POST['UserEmail'], PASSWORD_RECOVER_SUBJECT, $message);
                cmn_redirect('index.php');
            }        
        }
	}
	else
	{
		$_SESSION['MESSAGES'] = array("password_recovery_error");
        cmn_redirect('index.php'); 
	}
}
else
{
	$template->setVariable('UserEmail', @$_POST['UserEmail']);
	$template->touchBlock('password_recovery_form');
}

require('includes/application_bottom.php');