<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include("includes/application_top.php");

if (Session::isCurrentSessionLoggedIn())
{
	cmn_redirect(SITE_URL . "messages.php");
}

$user = new User(@$_GET['id']);
if ($user->UserType != USER_TYPE_INVITED)
{
	$user = new User();
}
$userData = $user->getDataArray();

if (isset($_POST['submitted']))
{
	if (!isset($_POST['cancel']))
	{
		$error = false;
		foreach ($userData as $field => $value)
		{
			switch ($field)
			{
				case 'Password':
					if (!isset($_POST[$field]))
					{
						$template->touchBlock('Password_empty');
						$error = true;
					}
					if (strpos(strval($_POST[$field]), " "))
					{
						$template->touchBlock('Password_characters');
						$error = true;
					}
					$passLen = strlen($_POST[$field]);
					if ($passLen < MIN_PASSWORD_LENGTH || $passLen > MAX_PASSWORD_LENGTH)
					{
						$template->touchBlock('Password_length');
						$error = true;
					}
					$userData['Password'] = $_POST[$field];
					break;
				case 'UserEmail':
					if (!isset($_POST[$field]) || strlen(trim($_POST[$field])) == 0)
					{
						$template->touchBlock('UserEmail_empty');
						$error = true;
					}
					if (preg_match('/' . REGEXP_EMAIL . '/', $_POST[$field]) == 0)
					{
						$template->touchBlock('UserEmail_format');
						$error = true;
					}
					$checkUser = User::getByUserEmail($_POST[$field]);
					if ($checkUser->UserID != -1 && $checkUser->UserType != USER_TYPE_INVITED)
					{
						$template->touchBlock('UserEmail_exists');
						$error = true;
					}
					$userData['UserEmail'] = trim($_POST[$field]);
					break;
				case 'UserFirstname':
				case 'UserLastname':
					if (!$_POST[$field])
					{
						$template->touchBlock($field . '_error');
						$error = true;
					}
					$userData[$field] = @$_POST[$field];
					break;
					$userData[$field] = ud_sanitize_string($_POST[$field]);
			}
		}
		if (!$error)
		{
			$_SESSION['userdata'] = $userData;
			$user->populateFromArray($userData);
			$user->Password = md5($_POST['Password']);
			$user->saveToDB();

			$fid = forum_insertforum($user->UserFirstname . ' ' . $user->UserLastname, 5);
			$user->UserForumID = $fid;
			$user->saveToDB();

			$user = User::createFromEmailLogin($_POST['UserEmail'], $_POST['Password']);
			setcookie('comm_sid', session_id());

			if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/wiki/');
			require_once(DOKU_INC.'inc/init.php');
			require_once(DOKU_INC.'inc/common.php');
			require_once(DOKU_INC.'inc/events.php');
			require_once(DOKU_INC.'inc/pageutils.php');
			require_once(DOKU_INC.'inc/html.php');
			require_once(DOKU_INC.'inc/auth.php');
			require_once(DOKU_INC.'inc/actions.php');
			
			auth_login($_POST['UserEmail'], $_POST['Password']);

			$db = DBConnect::getInstance();

			$_SESSION['user'] = $user;

			cmn_redirect("register_forum.php");
		}
	}
	else
	{
		cmn_redirect('index.php');
	}
}

$template->setVariable('MaxUserEmailLength', MAX_EMAIL_LENGTH);
$template->setVariable('MaxPasswordLength', MAX_PASSWORD_LENGTH);
$template->setVariable('MaxUserNameLength', MAX_PERSON_NAME_LENGTH);

$template->setVariable($userData);

require("includes/application_bottom.php");
?>