<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$video = new Video($_GET['video_id']);
$video_album = $video->getVideoAlbum();
$admin_perms = $video_album->checkPermission('edit');

if ($video->VideoID != -1 && $video_album->checkPermission('view'))
{
    $template->setGlobalVariable('VideoAlbumID', $video_album->VideoAlbumID);
    if ($video_album->GroupID != -1)
    {
        $template->setVariable('Entity', 'group');
        $template->setVariable('EntityID', $video_album->GroupID);
        $template->parse('back_link');
    }
    else if ($video_album->OrganizationID != -1)
    {
        $template->setVariable('Entity', 'organization');
        $template->setVariable('EntityID', $video_album->OrganizationID);
        $template->parse('back_link');
    }


	if ($admin_perms)
	{
		$template->touchBlock('videoadmin');
		
		if ($_POST['action'] == 'edit')
		{
			$video_album->clearCover();
			$video->VideoIsCover = 1;
			$video->saveToDB();
		}
		if ($_GET['action'] == 'delete_comment')
		{
			$comment = new Comment($_GET['comment_id']);
			if ($comment->CommentID != -1)
			{
				$comment->delete();
			}
		}
		if ($_GET['action'] == 'delete')
		{
			$video->delete();
			cmn_redirect('videos.php?video_album_id=' . $video_album->VideoAlbumID);
		}
		if ($video->VideoIsCover)
		{
			$template->touchBlock('cover_video');
		}
		else
		{
			$template->touchBlock('set_cover');
		}

	}
	if ($_POST['action'] == 'comment' && $_POST['CommentText'])
	{
		$comment = new Comment();
		$comment->VideoID = $video->VideoID;
		$comment->CommentText = $_POST['CommentText'];
		$comment->UserID = $user->UserID;
		$comment->saveToDB();
	}

	$template->setVariable("ImgURL", $video->getVideoURL(false));
	$template->setVariable("VIDEO_URL", "../." . PATH_VIDEO_ALBUM_PICS . $video_album->VideoAlbumID . "/" . $video->VideoPath);
	$template->setGlobalVariable("VideoID", $video->VideoID);


	$comments = $video->getVideoComments();
	foreach ($comments as $comment)
	{
		$template->setVariable('UserName',    $comment['UserName']);
		$template->setVariable('CommentText', $comment['CommentText']);
		$template->setVariable('CommentID',   $comment['CommentID']);
		$template->parse('comment');
		if ($admin_perms)
		{
			$template->parse('delete_comment');
		}
	}

}
else
{
	cmn_unathorized_action();
}

include('includes/application_bottom.php');