<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unauthorized_action();
}

$video_album = new VideoAlbum($_GET['video_album_id']);

if ($video_album->VideoAlbumID != -1)
{
    if ($video_album->GroupID != -1)
    {
        $template->setVariable('Entity', 'group');
        $template->setVariable('EntityID', $video_album->GroupID);
        $template->parse('back_link');
    }
    else if ($video_album->OrganizationID != -1)
    {
        $template->setVariable('Entity', 'organization');
        $template->setVariable('EntityID', $video_album->OrganizationID);
        $template->parse('back_link');
    }

    $owner = $video_album->getOwner();
    $type = strtolower(get_class($owner));
    $owner_id   = $owner->{ucfirst(get_class($owner)) . 'ID'};
	if ($type != 'user')
    {
        if (!$owner->userIsAdmin($user->UserID) && $owner->{ucfirst($type) . 'Status'} != GROUP_STATUS_PUBLIC)
        {
            cmn_unauthorized_action();
        }
    }
    if ($video_album->checkPermission('edit'))
    {
        if ($_POST['action'] == 'upload')
        {
            $path = './tmp/video_album/' . $_POST['video_album_id'] . '/';
            cmn_create_path($path, false);
            $d = dir($path);
            $videos = array();
            while (false !== ($file = $d->read()))
            {
                if ($file != '.' && $file != '..')
                {
                    $pathinfo = pathinfo($file);

                    $video = new Video();
                    $video->VideoAlbumID = $video_album->VideoAlbumID;
                    $video->VideoPath = time() . $pathinfo['basename'];
                    $video->VideoName = $pathinfo['basename'];
                    $video->saveToDB();

                    cmn_create_path(PATH_VIDEO_ALBUM_PICS . $video_album->VideoAlbumID, false);
                    rename($path . $file, PATH_VIDEO_ALBUM_PICS . $video_album->VideoAlbumID . "/" . $video->VideoPath);

                    $videopath = PATH_VIDEO_ALBUM_PICS . $video_album->VideoAlbumID;
                    $videoname = $video->VideoID;
                    $videos[] = $video;
                }
            }
            foreach ($videos as $video)
            {
                 $template->setVariable('VideoID',             $video->VideoID);
                 $template->setVariable('VideoName',         $video->VideoName);
                 $template->setVariable('VideoThumbnail',   $video->getVideoURL(true));
                 $template->parse('video_line');
            }
            $template->hideBlock('upload_form');
            $template->setVariable('VideoAlbumID', $video_album->VideoAlbumID);
            $template->touchBlock('videos_form');

            $template->touchBlock('buttons');
        }
        else if ($_POST['action'] == 'save')
        {
        	if (is_array($_POST['VideoName']))
            foreach ($_POST['VideoName'] as $id => $name)
            {
                $video = new Video($id);
                if (isset($_POST['delvideo'][$id]))
                {
                    $video->delete();
                    continue;
                }

                $video->VideoName = $name;
                $video->saveToDB();
            }
            cmn_redirect('video_albums.php?type=' . $type . '&id=' . $owner_id);
        }
        else
        {
            $template->setGlobalVariable('video_album_id', $video_album->VideoAlbumID);
            $template->setGlobalVariable('VideoAlbumID', $video_album->VideoAlbumID);
            $template->setVariable('session_id', session_id());
            $template->touchBlock('upload_form');
            $template->touchBlock('steps');
        }
    }
    else
    {
        cmn_unauthorized_action();
    }
}
else
{
    cmn_unauthorized_action();
}
$template->setVariable('UPLOAD_SCRIPT_PATH', dirname($_SERVER["REQUEST_URI"])."/");

require_once('includes/application_bottom.php');